<?php

namespace FiloBlu\Refilo\Model\Indexer;

use FiloBlu\Refilo\Model\Adapter\Mongo;
use Magento\Framework\App\ResourceConnection;

class Countries
{
    /**
     * @var ResourceConnection
     */
    private $resourceConnection;
    /**
     * @var Mongo
     */
    private $mongo;

    /**
     * Countries constructor.
     * @param ResourceConnection $resourceConnection
     * @param Mongo $mongo
     */
    public function __construct(
        ResourceConnection $resourceConnection,
        Mongo $mongo
    ) {
        $this->resourceConnection = $resourceConnection;
        $this->mongo = $mongo;
    }

    public function exportCountries()
    {
        $bulkData = [];

        $query = "SELECT * FROM filoblu_extamastygeoipredirect_country_continent as cc inner join filoblu_extamastygeoipredirect_continent as c on c.continent_id = cc.continent_id;";

        $result = $this->resourceConnection->getConnection()->fetchAll($query);
        foreach ($result as $item) {
            $country = new \stdClass();
            $country->_id = 'geocountry_' . $item['country_id'];

            $country->metadata = new \stdClass();
            $country->metacode = 'country';
            $country->metadata->code = $item['country_id'];
            $country->metadata->label = $item['country_name'];
            $country->metadata->continent_id = (int)$item['continent_id'];
            $country->metadata->continent_name = $item['continent'];
            $country->metadata->position = (int)$item['position'];
            $country->metadata->store = 'store_view_2';
            $country->metadata->marketplace = 'website_2';
            $country->metadata->regions = [];

            $query = "SELECT * FROM directory_country_region as cr WHERE country_id = " . '"' . $item['country_id'] . '"';
            $result_regions = $this->resourceConnection->getConnection()->fetchAll($query);
            if (count($result_regions)) {
                foreach ($result_regions as $result_region) {
                    $region = new \stdClass();
                    $region->id = $result_region["region_id"];
                    $region->code = $result_region["code"];
                    $region->name = $result_region["default_name"];
                    $country->metadata->regions[] = $region;
                }
            }
            $bulkData[] = $country;
        }
        $this->mongo->update(
            '_id',
            $bulkData,
            'config',
            true,
            'refilo'
        );
    }
}
